const Log = require("tp-log");
let DB;
let email;
try {
    DB = require("tp-db");
} catch (e) {}

try {
    email = require("tp-email");
} catch (e) {}

module.exports.throw = function(message, err) {
    Log.error(message, err);
    new Error(message, err);

    if(DB) {
        DB.req("mongo", "errors", "new", new Error(message, err), function(err) {
            if (err) {
                console.error("Unable to save error report in database.");
                console.error(err);
            }
        })
    }

    if (email) {
        email.send({to: "kriss@trespass.co.uk", subject: "ERROR: " + message, body: "The following error occurred: <br> " + message + "<br>&nbsp;<br> Error details: <br>" + JSON.stringify(err)}, "error", function (err) {});
    }
};

module.exports.clear = function(callback) {
    if(DB) {
        DB.req("mongo", "errors", "clear",{}, function(err) {
            if (err) {
                console.error("Unable to clear error reports in database.");
                console.error(err);
                callback(err);
            } else {
                callback(null);
            }
        })
    }
};

module.exports.get = function(callback) {
    if(DB) {
        DB.req("mongo", "errors", "get",{}, function(err, errors) {
            if (err) {
                console.error("Unable to fetch error reports from the database.");
                console.error(err);
                callback(err);
            } else {
                callback(errors);
            }
        })
    }
};

function Error(message, err) {
    this.message = message;
    this.err = err;
    this.date = new Date();
}